<template>
  <div class="chapter-container" :class="{ done: chapter.done, hide: !show }">
    <div
      class="chapter"
      v-wave="{ initialOpacity: 0.1, finalOpacity: 0.05 }"
      @click="chapterWindow(chapter)"
    >
      <div class="chapter-image">
        <img :src="require(`../assets/${chapter.type}.svg`)" />
      </div>
      <div class="chapter-title">
        {{ chapter.title }}
      </div>
    </div>
    <div
      class="chapter-done-btn"
      @click="toggleDone(chapter.id, chapter.done)"
    ></div>
    <transition-group name="fade-fast">
      <div
        v-if="isEditing"
        class="x-btn-chapter"
        @click="removeChapter(chapter.id)"
        data-tool="מחק פרק"
      ></div>
      <div
        v-if="isEditing"
        class="edit-btn-chapter"
        @click="editChapter(chapter)"
        data-tool="ערוך פרק"
      ></div>
    </transition-group>
  </div>
</template>

<script>
export default {
  props: ['chapter', 'unitid'],
  data() {
    return {
      show: true,
    }
  },
  methods: {
    chapterDone(id) {
      this.$store.dispatch('changeChapterStatus', { id: id, status: true })
    },
    toggleDone(id, status) {
      this.$store.dispatch('changeChapterStatus', { id: id, status: !status })
    },
    removeChapter(id) {
      if (window.confirm(`למחוק את פרק: ${this.chapter.title} ?`)) {
        this.$store.dispatch('removeChapter', {
          unitid: this.unitid,
          chapterid: id,
        })
      }
    },
    editChapter(chapter) {
      this.editChapterWindow(chapter)
    },
  },
  computed: {
    isEditing() {
      return this.$store.state.isEditing
    },
    loggedIn() {
      return this.$store.state.user != null
    },
  },
  inject: ['chapterWindow', 'editChapterWindow'],
}
</script>

<style scoped>
.chapter-container {
  margin: 2em;
  position: relative;
  transition: box-shadow 0.2s, transform 1s, opacity 1s;
  --opacity: 0;
}

.chapter-container:hover {
  z-index: 1;
  transform: translateY(-1%);
  --opacity: 1;
  transition: transform 0.2s;
}

.chapter-container.hide {
  opacity: 0;
  transform: translateY(-10%);
}

.chapter {
  position: relative;
  cursor: pointer;
  user-select: none;
  height: 20em;
  width: 20em;
  border-radius: 2em;
  background-color: #fff;
  box-shadow: 0 0 1em var(--lightBlue);
  display: grid;
  grid-template-rows: 1fr auto;
  transition: box-shadow 0.2s, transform 0.2s;
  --color: var(--lightBlue);
}

.chapter:hover {
  box-shadow: 0 0 1em hsl(240, 100%, 95%);
  --opacity: 1;
}

.done .chapter {
  --color: var(--lightGreen);
}

.chapter-image {
  display: flex;
  align-items: center;
  justify-content: center;
}

.chapter-image img {
  pointer-events: none;
  height: 10em;
}

.done .chapter-image img {
  filter: invert(1) sepia(1) saturate(15) hue-rotate(120deg);
}

.chapter-title {
  border-radius: 0 0 1.4rem 1.4rem;
  padding: 0.5em 1em;
  padding-bottom: 0.75em;
  font-weight: bold;
  text-align: center;
  font-size: 1.5em;
  background-color: var(--color);
  color: var(--blue);
}

.chapter-done-btn {
  user-select: none;
  cursor: pointer;
  opacity: var(--opacity);
  position: absolute;
  top: 0;
  right: 0;
  margin: 1em;
  height: 2em;
  width: 2em;
  border-radius: 50%;
  border: 2px solid hsl(240, 100%, 96%);
  transition: opacity 0.2s;
  background-position: center;
  background-size: cover;
  display: flex;
  justify-content: center;
  align-items: center;
}

.chapter-done-btn::after {
  opacity: 0;
  transition: opacity 0.2s, border-width 0.2s;
  content: '';
  position: absolute;
  height: 100%;
  width: 100%;
  border-radius: 50%;
  border: 2px solid;
  border-color: var(--lightGreen2);
  background-image: url(../assets/done2.svg);
  background-position: center;
  background-size: cover;
}

.done .chapter-done-btn {
  opacity: 1;
}

.done .chapter-done-btn::after {
  background-color: var(--lightGreen2);
  border-color: var(--lightGreen2);
  background-image: url(../assets/done.svg);
  opacity: 1;
}

.chapter-done-btn:hover::after {
  opacity: 1;
}

.chapter-done-btn img {
  pointer-events: none;
  opacity: var(--imgOpacity);
  width: 100%;
}
</style>
